<?php
namespace Folha\Repositories;

use HCM\Util\DateUtil;

class VabLinhavinc extends \Doctrine\ORM\EntityRepository
{
    /**
     * Busca os vales para o mês
     *
     * @param int $nrvinculom
     * @param int $nrorg
     * @param string $dtiniperiodo
     * @param string $dtfimperiodo
     * @param int $nrtipolinhavinc
     * @return array|bool
     */
    public static function infoLinhaVinculoTarifa($nrvinculom, $nrorg, $dtiniperiodo, $dtfimperiodo, $nrtipolinhavinc = null, $nrorgpadrao)
    {
        if($dtiniperiodo instanceof \DateTime){
            $dtiniperiodo = $dtiniperiodo->format('d/m/Y');
        }
        if($dtfimperiodo instanceof \DateTime){
            $dtfimperiodo = $dtfimperiodo->format('d/m/Y');
        }

        $sql = <<<SQL
SELECT
    VAB_LINHA.NRLINHATRANSP,
    VAB_LINHATARIFA.NRTARIFA,
    VAB_LINHAVINC.NRVINCULOM,
    VAB_LINHAVINC.IDDIASSEMANA,
    SENTIDOLINHA.NRSENTIDOLINHA,
    VAB_LINHAVINC.NRTIPOLINHAVINC,
    VAB_LINHAVINC.QTLINHATARIFA,
    VAB_TARIFA.VRTARIFA,
    VAB_LINHAVINC.DTINILINHAVINC
FROM VAB_LINHAVINC

INNER JOIN VAB_LINHA
    ON VAB_LINHAVINC.NRORG = VAB_LINHA.NRORG
    AND VAB_LINHAVINC.NRLINHATARIFA = VAB_LINHA.NRLINHATRANSP

INNER JOIN VAB_LINHATARIFA
    ON VAB_LINHATARIFA.NRLINHATRANSP = VAB_LINHA.NRLINHATRANSP
    AND VAB_LINHATARIFA.NRORG = VAB_LINHA.NRORG

INNER JOIN VAB_TARIFA
    ON VAB_TARIFA.NRTARIFA = VAB_LINHATARIFA.NRTARIFA
    AND (VAB_TARIFA.NRORG = VAB_LINHATARIFA.NRORG OR VAB_TARIFA.NRORG = $nrorgpadrao)

INNER JOIN SENTIDOLINHA
    ON VAB_LINHAVINC.NRSENTIDOLINHA = SENTIDOLINHA.NRSENTIDOLINHA
    AND (VAB_LINHAVINC.NRORG = SENTIDOLINHA.NRORG OR SENTIDOLINHA.NRORG = $nrorgpadrao)

INNER JOIN TIPOLINHAVINC
    ON VAB_LINHAVINC.NRTIPOLINHAVINC = TIPOLINHAVINC.NRTIPOLINHAVINC
    AND (VAB_LINHAVINC.NRORG = TIPOLINHAVINC.NRORG OR TIPOLINHAVINC.NRORG = $nrorgpadrao)

WHERE VAB_LINHAVINC.NRORG = $nrorg
    AND VAB_LINHAVINC.NRVINCULOM = $nrvinculom
    AND VAB_LINHAVINC.DTINILINHAVINC <= '$dtiniperiodo'
    AND (VAB_LINHAVINC.DTFIMLINHAVINC >='$dtfimperiodo' OR VAB_LINHAVINC.DTFIMLINHAVINC IS NULL)
    AND  VAB_LINHATARIFA.DTINILINHATARIFA <= '$dtiniperiodo'
    AND (VAB_LINHATARIFA.DTFIMLINHATARIFA >= '$dtfimperiodo' OR VAB_LINHATARIFA.DTFIMLINHATARIFA IS NULL)
    AND  VAB_LINHA.DTINILINHA <= '$dtiniperiodo'
    AND (VAB_LINHA.DTFIMLINHA >= '$dtfimperiodo' OR VAB_LINHA.DTFIMLINHA IS NULL)
    AND (VAB_LINHAVINC.NRTIPOLINHAVINC = '$nrtipolinhavinc' OR '$nrtipolinhavinc' IS NULL)
SQL;

        //$result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $query = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();
        if($result){
            return $result;
        }else{
            return false;
        }

    }
    
    /**
     * Busca os vales para o mês
     *
     * @param int $nrvinculom
     * @param int $nrorg
     * @param string $dtiniperiodo
     * @param string $dtfimperiodo
     * @param int $nrtipolinhavinc
     * @return array|bool
     */
    public static function infoLinhaVinculoTarifaLinha($nrvinculom, $nrorg, $dtiniperiodo, $dtfimperiodo, $nrtipolinhavinc = null, $nrorgpadrao, $nrlinhatransp)
    {
        if($dtiniperiodo instanceof \DateTime){
            $dtiniperiodo = $dtiniperiodo->format('d/m/Y');
        }
        if($dtfimperiodo instanceof \DateTime){
            $dtfimperiodo = $dtfimperiodo->format('d/m/Y');
        }

        $sql = <<<SQL
SELECT
    VAB_LINHA.NRLINHATRANSP,
    VAB_LINHATARIFA.NRTARIFA,
    VAB_LINHAVINC.NRVINCULOM,
    VAB_LINHAVINC.IDDIASSEMANA,
    SENTIDOLINHA.NRSENTIDOLINHA,
    VAB_LINHAVINC.NRTIPOLINHAVINC,
    VAB_LINHAVINC.QTLINHATARIFA,
    VAB_TARIFA.VRTARIFA
FROM VAB_LINHAVINC

INNER JOIN VAB_LINHA
    ON VAB_LINHAVINC.NRORG = VAB_LINHA.NRORG
    AND VAB_LINHAVINC.NRLINHATARIFA = VAB_LINHA.NRLINHATRANSP

INNER JOIN VAB_LINHATARIFA
    ON VAB_LINHATARIFA.NRLINHATRANSP = VAB_LINHA.NRLINHATRANSP
    AND VAB_LINHATARIFA.NRORG = VAB_LINHA.NRORG

INNER JOIN VAB_TARIFA
    ON VAB_TARIFA.NRTARIFA = VAB_LINHATARIFA.NRTARIFA
    AND (VAB_TARIFA.NRORG = VAB_LINHATARIFA.NRORG OR VAB_TARIFA.NRORG = $nrorgpadrao)

INNER JOIN SENTIDOLINHA
    ON VAB_LINHAVINC.NRSENTIDOLINHA = SENTIDOLINHA.NRSENTIDOLINHA
    AND (VAB_LINHAVINC.NRORG = SENTIDOLINHA.NRORG OR SENTIDOLINHA.NRORG = $nrorgpadrao)

INNER JOIN TIPOLINHAVINC
    ON VAB_LINHAVINC.NRTIPOLINHAVINC = TIPOLINHAVINC.NRTIPOLINHAVINC
    AND (VAB_LINHAVINC.NRORG = TIPOLINHAVINC.NRORG OR TIPOLINHAVINC.NRORG = $nrorgpadrao)

WHERE VAB_LINHAVINC.NRORG = $nrorg
    AND VAB_LINHAVINC.NRVINCULOM = $nrvinculom
    AND VAB_LINHAVINC.DTINILINHAVINC <= '$dtiniperiodo'
    AND (VAB_LINHAVINC.DTFIMLINHAVINC >='$dtfimperiodo' OR VAB_LINHAVINC.DTFIMLINHAVINC IS NULL)
    AND  VAB_LINHATARIFA.DTINILINHATARIFA <= '$dtiniperiodo'
    AND (VAB_LINHATARIFA.DTFIMLINHATARIFA >= '$dtfimperiodo' OR VAB_LINHATARIFA.DTFIMLINHATARIFA IS NULL)
    AND  VAB_LINHA.DTINILINHA <= '$dtiniperiodo'
    AND (VAB_LINHA.DTFIMLINHA >= '$dtfimperiodo' OR VAB_LINHA.DTFIMLINHA IS NULL)
    AND (VAB_LINHAVINC.NRTIPOLINHAVINC = '$nrtipolinhavinc' OR '$nrtipolinhavinc' IS NULL)
    AND (VAB_LINHA.NRLINHATRANSP = '$nrlinhatransp')
SQL;

        //$result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $query = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();
        if($result){
            return $result;
        }else{
            return false;
        }

    }
}